package com.tzld.longarticle.recommend.server.service;

import cn.hutool.core.io.resource.ResourceUtil;
import com.alibaba.fastjson.JSONObject;
import com.tzld.longarticle.recommend.server.service.score.AvgReadDTO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;

@Component
@Slf4j
public class AccountIndexAvgViewCountService {

    private JSONObject accountInfo;

    @PostConstruct
    public void init() {
        String cardJSON = ResourceUtil.readUtf8Str("file/AccountInfo.json");
        accountInfo = JSONObject.parseObject(cardJSON);
    }


    public AvgReadDTO getAvgReadDto(String key) {
        return accountInfo.getObject(key, AvgReadDTO.class);
    }

    public double getAvgReadCount(String ghId, Integer index) {
        AvgReadDTO dto =getAvgReadDto(ghId + "_" + index);
        return dto == null ? 1.0 : dto.getReadAvg();
    }

}
