package com.tzld.longarticle.recommend.server.service.rank;


import com.tzld.longarticle.recommend.server.common.enums.RankStrategyEnum;
import com.tzld.longarticle.recommend.server.service.ServiceBeanFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * @author dyp
 */
@Service
@Slf4j
public class RankService {

    public RankResult rank(RankParam param) {
        RankStrategy strategy = getRankStrategy(param);
        return strategy.rank(param);
    }

    private RankStrategy getRankStrategy(RankParam param) {
        RankStrategyEnum rankStrategyEnum = RankStrategyEnum.from(param.getStrategy());
        return (RankStrategy) ServiceBeanFactory.getBeanByName(rankStrategyEnum.getTaskExecutorName());
    }

}
