package com.tzld.longarticle.recommend.server.service.recall.strategy;

import com.tzld.longarticle.recommend.server.model.Content;
import com.tzld.longarticle.recommend.server.service.filter.FilterParam;
import com.tzld.longarticle.recommend.server.service.filter.FilterResult;
import com.tzld.longarticle.recommend.server.service.filter.FilterService;
import com.tzld.longarticle.recommend.server.service.recall.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @author dyp
 */
@Component
@Slf4j
public class ColdStartBackupRecallStrategy implements RecallStrategy {

    @Autowired
    private FilterService filterService;
    @Autowired
    RecallService recallService;

    @Override
    public RecallResult.RecallData recall(RecallParam param) {
        List<Content> content = param.getContent();
        // 处理 content
        FilterParam filterParam = FilterParamFactory.create(param, content);
        filterParam.setBackup(true);
        FilterResult filterResult = filterService.filter(filterParam);
        // 处理 content
        RecallResult.RecallData result = new RecallResult.RecallData();
        result.setContents(content.stream().filter(o -> filterResult.getContentIds().contains(o.getId()))
                .collect(Collectors.toList()));
        result.setFilterContents(filterResult.getFilterContent());
        result.setBackup(true);
        return result;
    }

}
