package com.tzld.longarticle.recommend.server;

import com.alibaba.fastjson.JSONObject;
import com.tzld.longarticle.recommend.server.model.Content;
import com.tzld.longarticle.recommend.server.service.score.Score;
import com.tzld.longarticle.recommend.server.service.score.ScoreParam;
import com.tzld.longarticle.recommend.server.service.score.strategy.ViewMultiplierStrategy;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

@SpringBootTest(classes = Application.class)
public class ScoreStrategyTest {

    @Resource
    ViewMultiplierStrategy viewMultiplierStrategy;

    @Test
    public void viewMultiplierStrategy() {
        ScoreParam param = new ScoreParam();
        List<Content> contentList = new ArrayList<>();
        Content content0 = new Content();
        content0.setCrawlerChannelContentId("0065561559007185d167afdd61b9ac5a");
        contentList.add(content0);
        Content content1 = new Content();
        content1.setCrawlerChannelContentId("0072aefb5bed07343469045bdd812ee0");
        contentList.add(content1);
        param.setContents(contentList);
        List<Score> result = viewMultiplierStrategy.score(param);
        System.out.println(JSONObject.toJSONString(result));
    }

}
